SystemOrganization addCategory: #'Magritte-Tutorial-Model'!
SystemOrganization addCategory: #'Magritte-Tutorial-View'!

Object subclass: #MAAddressModel
	instanceVariableNames: 'street plz place canton nationality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-Model'!

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:42'!
descriptionCanton
	^ MASingleOptionDescription new
		options: #( 'Zurich' 'Bern' 'Luzern' 'Uri' 'Schwyz' 'Unterwalden' 'Glarus' 'Zug' 'Freiburg' 'Solothurn' 'Basel' 'Schaffhausen' 'Appenzell' 'St. Gallen' 'Graubunden' 'Aargau' 'Thurgau' 'Ticino' 'Vaud' 'Valais' 'Neuchatel' 'Geneve' 'Jura' );
		reference: MAStringDescription new;
		accessor: #canton;
		label: 'Canton';
		priority: 40;
		beSorted;
		yourself! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:42'!
descriptionPlace
	^ MAStringDescription new
		accessor: #place;
		label: 'Place';
		priority: 30;
		yourself! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:42'!
descriptionPlz
	^ MANumberDescription new
		accessor: #plz;
		label: 'PLZ';
		priority: 20;
		min: 1000;
		max: 9999;
		yourself! !

!MAAddressModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:42'!
descriptionStreet
	^ MAStringDescription new
		accessor: #street;
		label: 'Street';
		priority: 10;
		yourself! !

!MAAddressModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
= anObject
	^ self species = anObject species
		and: [ self street = anObject street
		and: [ self plz = anObject plz
		and: [ self place = anObject place
		and: [ self canton = anObject canton ] ] ] ]! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
canton
	^ canton! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
canton: anObject
	canton := anObject! !

!MAAddressModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
hash
	^ self street hash bitXor: self place hash! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
nationality
	^ nationality! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
nationality: anObject
	nationality := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
place
	^ place! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
place: anObject
	place := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
plz
	^ plz! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
plz: anObject
	plz := anObject! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
street
	^ street! !

!MAAddressModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:53'!
street: anObject
	street := anObject! !

Object subclass: #MAPersonModel
	instanceVariableNames: 'title firstName lastName email homeAddress officeAddress picture birthday phones password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-Model'!

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 7/14/2007 09:15'!
descriptionAge
	^ MANumberDescription new
		selectorAccessor: #age;
		label: 'Age';
		priority: 80;
		beReadonly;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:42'!
descriptionBirthday
	^ MADateDescription new
		accessor: #birthday;
		label: 'Birthday';
		priority: 70;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:42'!
descriptionFirstName
	^ MAStringDescription new
		accessor: #firstName;
		label: 'First Name';
		priority: 20;
		beRequired;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionHomeAddress
	^ MAToOneRelationDescription new
		componentClass: MAInternalEditorComponent;
		classes: (Array with: MAAddressModel);
		accessor: #homeAddress;
		label: 'Home Address';
		priority: 40;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionLastName
	^ MAStringDescription new
		accessor: #lastName;
		label: 'Last Name';
		priority: 30;
		beRequired;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionOfficeAddress
	^ MAToOneRelationDescription new
		componentClass: MAExternalEditorComponent;
		classes: (Array with: MAAddressModel);
		accessor: #officeAddress;
		label: 'Office Address';
		priority: 50;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 11/6/2009 15:14'!
descriptionPassword
	^ MAPasswordDescription new
		componentClass: MAVerifiedPasswordComponent;
		accessor: #password;
		label: 'Password';
		priority: 100;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionPhoneNumbers
	^ MAToManyRelationDescription new
		classes: (Array with: MAPhoneModel);
		label: 'Phone Numbers';
		default: Array new;
		accessor: #phones;
		priority: 90;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionPicture
	^ MAFileDescription new
		addCondition: [ :value | value isImage ] labelled: 'Image expected';
		accessor: #picture;
		label: 'Picture';
		priority: 60;
		yourself! !

!MAPersonModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionTitle
	^ MASingleOptionDescription new
		options: #( 'Mr.' 'Mrs.' 'Ms.' 'Miss.' );
		accessor: #title;
		label: 'Title';
		priority: 10;
		yourself! !

!MAPersonModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
= anObject
	^ self species = anObject species
		and: [ self title = anObject title
		and: [ self firstName = anObject firstName
		and: [ self lastName = anObject lastName
		and: [ self picture = anObject picture
		and: [ self birthday = anObject birthday
		and: [ self officeAddress = anObject officeAddress
		and: [ self homeAddress = anObject homeAddress ] ] ] ] ] ] ]! !

!MAPersonModel methodsFor: 'accessing-calculated' stamp: 'lr 11/29/2006 00:00'!
age
	^ self birthday notNil
		ifTrue: [ Date current year - self birthday year ]! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
birthday
	^ birthday! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
birthday: anObject
	birthday := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
email
	^ email! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
email: anObject
	email := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:49'!
firstName
	^ firstName! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
firstName: anObject
	firstName := anObject! !

!MAPersonModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
hash
	^ self firstName hash bitXor: self lastName hash! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
homeAddress
	^ homeAddress! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
homeAddress: anObject
	homeAddress := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
lastName
	^ lastName! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
lastName: anObject
	lastName := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
officeAddress
	^ officeAddress! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
officeAddress: anObject
	officeAddress := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 11/6/2009 15:15'!
password
	^ password! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 11/6/2009 15:15'!
password: aString
	password := aString! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
phones
	^ phones! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
phones: anObject
	phones := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:50'!
picture
	^ picture! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
picture: anObject
	picture := anObject! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:49'!
title
	^ title! !

!MAPersonModel methodsFor: 'accessing' stamp: 'lr 1/13/2006 18:52'!
title: anObject
	title := anObject! !

Object subclass: #MAPhoneModel
	instanceVariableNames: 'kind number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-Model'!

!MAPhoneModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionKind
	^ MAStringDescription new
		accessor: #kind;
		label: 'Kind';
		priority: 10;
		yourself! !

!MAPhoneModel class methodsFor: 'accessing-description' stamp: 'lr 5/17/2009 22:43'!
descriptionNumber
	^ MAStringDescription new
		accessor: #number;
		label: 'Number';
		priority: 20;
		yourself! !

!MAPhoneModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
= anObject
	^ self species = anObject species
		and: [ self kind = anObject kind
		and: [ self number = anObject number ] ]! !

!MAPhoneModel methodsFor: 'comparing' stamp: 'lr 11/29/2006 00:00'!
hash
	^ self kind hash bitXor: self number hash! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
kind
	^ kind! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
kind: anObject
	kind := anObject! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
number
	^ number! !

!MAPhoneModel methodsFor: 'accessing' stamp: 'lr 11/28/2006 23:31'!
number: anObject
	number := anObject! !

WAComponent subclass: #MAPersonEditor
	instanceVariableNames: 'person component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Tutorial-View'!

!MAPersonEditor class methodsFor: 'initialize' stamp: 'lr 11/29/2006 00:02'!
initialize
	self registerAsApplication: 'personeditor'! !

!MAPersonEditor methodsFor: 'private' stamp: 'lr 9/12/2007 17:27'!
buildComponent
	^ self person asComponent
		addValidatedForm;
		yourself! !

!MAPersonEditor methodsFor: 'accessing-dynamic' stamp: 'lr 11/29/2006 00:02'!
children
	^ Array with: self component! !

!MAPersonEditor methodsFor: 'accessing-dynamic' stamp: 'lr 11/29/2006 00:02'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!MAPersonEditor methodsFor: 'accessing' stamp: 'lr 11/29/2006 00:02'!
person
	^ person ifNil: [ person := MAPersonModel new ]! !

!MAPersonEditor methodsFor: 'rendering' stamp: 'lr 11/29/2006 00:02'!
renderContentOn: html
	html heading: 'Edit Person'.
	html render: self component! !
MAPersonEditor initialize!
